#Copyright 2001 by R. David Murray and FCGNetworks (http://www.fcgnetworks.net)
#Governed by the Artistic License
#  http://www.opensource.org/licenses/artistic-license.html

#For version 0.0.1

from unittest import TestCase, makeSuite, TextTestRunner
from os import remove, popen
from xfile import xfile

capturefn = 'zopectlTests.capture'
defaultfn = 'zopectlTests.defaults'
subparmfn = 'zopectlTests.parms'

def capture(arglist):
  f = open(capturefn,'w')
  for arg in arglist:
    f.write("%s\n" % arg)
  f.close()

def makefile(fn,lines):
  f = open(fn,'w')
  for line in lines:
    f.write(line+'\n')
  f.close()


class TestCases(TestCase):

  def setUp(self):
    try:
      remove(capturefn)
      remove(defaultfn)
      remove(subparmfn)
    except OSError: pass
  tearDown = setUp

  def assertEQ(self,res,correct,msg=''):
    assert res==correct, "%s <> %s %s" % (repr(res),repr(correct),msg)

  def assertSeqEQ(self,seq1,seq2):
    for i in range(len(seq2)):
      self.assertEQ(seq1[i],seq2[i],"(line %s)" % i)
    self.assertEQ(len(seq1),len(seq2))

  def assertCmdOutIs(self,args,out):
    self.assertSeqEQ(xfile(popen("./zopectl -f %s %s 2>&1" % (defaultfn,args))),
      out)

  def testNoArgs(self):
    self.assertCmdOutIs("",["zopectl: missing keyword (valid values are " +\
      "reload, restart, start, status and stop)"])

suite = makeSuite(TestCases,'test')

if __name__ == '__main__':
  from sys import exit, argv
  if argv[1:]: capture(argv[1:]); exit(0)
  if not TextTestRunner().run(suite).wasSuccessful(): exit(1)
